/*
	$Id: FunnelTree.java 223 2006-06-01 12:05:59Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import funneltree.TreeModel;
import funneltree.TreeNode;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

/**
   ƥȥեͥΥ饹ĥ꡼
*/
public class FunnelTree extends JTree {

    /** ǥץ쥤ɥ */
    private Display dpy;

    /** ĥ꡼򤵤ƤΡ */
    private TreeNode selectedNode;

    /** 饹ĥ꡼ΥΡɤΤꥹ */
    private FunnelTreeListener listener;

    /**
       ĥ꡼ޤ

       @param funnel ƥȥեͥ
    */
    public FunnelTree(final Funnel funnel) {
	super(new TreeModel(funnel.getClassNames()));
	funnel.addFunnelListener(new FunnelListener() {
	    public void recipeChanged() {
		setModel(new TreeModel(funnel.getClassNames()));
		resetSelection();
	    }
	    public void selectionChanged() {
	    }
	    public void statusChanged(final Test t) {
	    }
	    public void filterChanged() {
	    }
	    public void sortingChanged() {
	    }
	});
	listener = null;
	selectedNode = null;

	setShowsRootHandles(true);
	addMouseListener(new MouseAdapter() {
	    public void mousePressed(final MouseEvent ev) {
		if (getRowForLocation(ev.getX(), ev.getY()) == -1
		    || ev.getClickCount() != 2) {
		    return;
		}
		TreePath path = getPathForLocation(ev.getX(), ev.getY());
		TreeNode node = (TreeNode) path.getLastPathComponent();
		if (node != null && node == selectedNode) {
		    //System.out.println("double click");
		}
             }
	});
	addTreeSelectionListener(new TreeSelectionListener() {
	    public void valueChanged(final TreeSelectionEvent ev) {
		TreePath path = ev.getPath();
		TreeNode node = (TreeNode) path.getLastPathComponent();
		selectedNode = node;
		if (listener != null) {
		    listener.treeNodeSelected(node);
		}
	    }
	});

	resetSelection();

	TreeSelectionModel sm = getSelectionModel();
	sm.setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    }

    /**
       ĥ꡼֤ޤ
    */
    private void resetSelection() {
	for (int k = 0; k < getRowCount(); ++k) {
	    expandRow(k);
	}
	setSelectionRow(0);
    }

    /**
       եͥĥ꡼Υꥹʤꤷޤ

       @param listener եͥĥ꡼Υꥹ
    */
    public final void setFunnelTreeListener(
	final FunnelTreeListener listener) {
	this.listener = listener;
    }

    /**
       򤵤ƤΡɤ֤ޤ

       򤵤ƤΡɤʤnull֤ޤ

       @return 򤵤ƤΡɡޤnull
    */
    public final TreeNode getSelectedNode() {
	return selectedNode;
    }
}
