/*
	$Id: Stack.c 97 2006-03-01 13:11:45Z syl $

	Copyright (C) 2001 Syllabub
	Maroontress Fast Software.
*/

#include <stdlib.h>
#include "impl/Stack.h"
#include "impl/ArrayStack.h"
#include "impl/ListStack.h"

struct Stack *
Stack_create(int capacity)
{
    return ((capacity == 0)
	    ? impl_ListStack_create()
	    : impl_ArrayStack_create(capacity));
}

void
Stack_free(struct Stack *s)
{
    s->free(s);
}

int
Stack_push(struct Stack *s, struct StackCell *c)
{
    return s->push(s, c);
}

struct StackCell *
Stack_pop(struct Stack *s)
{
    return s->pop(s);
}

int
Stack_getSize(struct Stack *s)
{
    return s->nodes;
}

struct StackCell *
Stack_top(struct Stack *s)
{
    return s->peek(s);
}
